~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/usr/gen_initramfs.sh

Version: ~ [ linux-6.11.5 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.58 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.114 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.169 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.228 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.284 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.322 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.9 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

Diff markup

Differences between /usr/gen_initramfs.sh (Version linux-6.11.5) and /usr/gen_initramfs.sh (Version linux-5.10.228)


  1 #!/bin/sh                                           1 #!/bin/sh
  2 # Copyright (C) Martin Schlemmer <azarah@nosfer      2 # Copyright (C) Martin Schlemmer <azarah@nosferatu.za.org>
  3 # Copyright (C) 2006 Sam Ravnborg <sam@ravnborg      3 # Copyright (C) 2006 Sam Ravnborg <sam@ravnborg.org>
  4 #                                                   4 #
  5 # Released under the terms of the GNU GPL           5 # Released under the terms of the GNU GPL
  6 #                                                   6 #
  7 # Generate a cpio packed initramfs. It uses ge      7 # Generate a cpio packed initramfs. It uses gen_init_cpio to generate
  8 # the cpio archive.                                 8 # the cpio archive.
  9 # This script assumes that gen_init_cpio is lo      9 # This script assumes that gen_init_cpio is located in usr/ directory
 10                                                    10 
 11 # error out on errors                              11 # error out on errors
 12 set -e                                             12 set -e
 13                                                    13 
 14 usage() {                                          14 usage() {
 15 cat << EOF                                         15 cat << EOF
 16 Usage:                                             16 Usage:
 17 $0 [-o <file>] [-l <dep_list>] [-u <uid>] [-g      17 $0 [-o <file>] [-l <dep_list>] [-u <uid>] [-g <gid>] {-d | <cpio_source>} ...
 18         -o <file>      Create initramfs file n     18         -o <file>      Create initramfs file named <file> by using gen_init_cpio
 19         -l <dep_list>  Create dependency list      19         -l <dep_list>  Create dependency list named <dep_list>
 20         -u <uid>       User ID to map to user      20         -u <uid>       User ID to map to user ID 0 (root).
 21                        <uid> is only meaningfu     21                        <uid> is only meaningful if <cpio_source> is a
 22                        directory.  "squash" fo     22                        directory.  "squash" forces all files to uid 0.
 23         -g <gid>       Group ID to map to grou     23         -g <gid>       Group ID to map to group ID 0 (root).
 24                        <gid> is only meaningfu     24                        <gid> is only meaningful if <cpio_source> is a
 25                        directory.  "squash" fo     25                        directory.  "squash" forces all files to gid 0.
 26         -d <date>      Use date for all file m << 
 27         <cpio_source>  File list or directory      26         <cpio_source>  File list or directory for cpio archive.
 28                        If <cpio_source> is a .     27                        If <cpio_source> is a .cpio file it will be used
 29                        as direct input to init     28                        as direct input to initramfs.
 30                                                    29 
 31 All options except -o and -l may be repeated a     30 All options except -o and -l may be repeated and are interpreted
 32 sequentially and immediately.  -u and -g state     31 sequentially and immediately.  -u and -g states are preserved across
 33 <cpio_source> options so an explicit "-u 0 -g      32 <cpio_source> options so an explicit "-u 0 -g 0" is required
 34 to reset the root/group mapping.                   33 to reset the root/group mapping.
 35 EOF                                                34 EOF
 36 }                                                  35 }
 37                                                    36 
 38 # awk style field access                           37 # awk style field access
 39 # $1 - field number; rest is argument string       38 # $1 - field number; rest is argument string
 40 field() {                                          39 field() {
 41         shift $1 ; echo $1                         40         shift $1 ; echo $1
 42 }                                                  41 }
 43                                                    42 
 44 filetype() {                                       43 filetype() {
 45         local argv1="$1"                           44         local argv1="$1"
 46                                                    45 
 47         # symlink test must come before file t     46         # symlink test must come before file test
 48         if [ -L "${argv1}" ]; then                 47         if [ -L "${argv1}" ]; then
 49                 echo "slink"                       48                 echo "slink"
 50         elif [ -f "${argv1}" ]; then               49         elif [ -f "${argv1}" ]; then
 51                 echo "file"                        50                 echo "file"
 52         elif [ -d "${argv1}" ]; then               51         elif [ -d "${argv1}" ]; then
 53                 echo "dir"                         52                 echo "dir"
 54         elif [ -b "${argv1}" -o -c "${argv1}"      53         elif [ -b "${argv1}" -o -c "${argv1}" ]; then
 55                 echo "nod"                         54                 echo "nod"
 56         elif [ -p "${argv1}" ]; then               55         elif [ -p "${argv1}" ]; then
 57                 echo "pipe"                        56                 echo "pipe"
 58         elif [ -S "${argv1}" ]; then               57         elif [ -S "${argv1}" ]; then
 59                 echo "sock"                        58                 echo "sock"
 60         else                                       59         else
 61                 echo "invalid"                     60                 echo "invalid"
 62         fi                                         61         fi
 63         return 0                                   62         return 0
 64 }                                                  63 }
 65                                                    64 
 66 print_mtime() {                                    65 print_mtime() {
 67         local my_mtime="0"                         66         local my_mtime="0"
 68                                                    67 
 69         if [ -e "$1" ]; then                       68         if [ -e "$1" ]; then
 70                 my_mtime=$(find "$1" -printf "     69                 my_mtime=$(find "$1" -printf "%T@\n" | sort -r | head -n 1)
 71         fi                                         70         fi
 72                                                    71 
 73         echo "# Last modified: ${my_mtime}" >>     72         echo "# Last modified: ${my_mtime}" >> $cpio_list
 74         echo "" >> $cpio_list                      73         echo "" >> $cpio_list
 75 }                                                  74 }
 76                                                    75 
 77 list_parse() {                                     76 list_parse() {
 78         if [ -z "$dep_list" -o -L "$1" ]; then     77         if [ -z "$dep_list" -o -L "$1" ]; then
 79                 return                             78                 return
 80         fi                                         79         fi
 81         echo "$1" | sed 's/:/\\:/g; s/$/ \\/'      80         echo "$1" | sed 's/:/\\:/g; s/$/ \\/' >> $dep_list
 82 }                                                  81 }
 83                                                    82 
 84 # for each file print a line in following form     83 # for each file print a line in following format
 85 # <filetype> <name> <path to file> <octal mode     84 # <filetype> <name> <path to file> <octal mode> <uid> <gid>
 86 # for links, devices etc the format differs. S     85 # for links, devices etc the format differs. See gen_init_cpio for details
 87 parse() {                                          86 parse() {
 88         local location="$1"                        87         local location="$1"
 89         local name="/${location#${srcdir}}"        88         local name="/${location#${srcdir}}"
 90         # change '//' into '/'                     89         # change '//' into '/'
 91         name=$(echo "$name" | sed -e 's://*:/:     90         name=$(echo "$name" | sed -e 's://*:/:g')
 92         local mode="$2"                            91         local mode="$2"
 93         local uid="$3"                             92         local uid="$3"
 94         local gid="$4"                             93         local gid="$4"
 95         local ftype=$(filetype "${location}")      94         local ftype=$(filetype "${location}")
 96         # remap uid/gid to 0 if necessary          95         # remap uid/gid to 0 if necessary
 97         [ "$root_uid" = "squash" ] && uid=0 ||     96         [ "$root_uid" = "squash" ] && uid=0 || [ "$uid" -eq "$root_uid" ] && uid=0
 98         [ "$root_gid" = "squash" ] && gid=0 ||     97         [ "$root_gid" = "squash" ] && gid=0 || [ "$gid" -eq "$root_gid" ] && gid=0
 99         local str="${mode} ${uid} ${gid}"          98         local str="${mode} ${uid} ${gid}"
100                                                    99 
101         [ "${ftype}" = "invalid" ] && return 0    100         [ "${ftype}" = "invalid" ] && return 0
102         [ "${location}" = "${srcdir}" ] && ret    101         [ "${location}" = "${srcdir}" ] && return 0
103                                                   102 
104         case "${ftype}" in                        103         case "${ftype}" in
105                 "file")                           104                 "file")
106                         str="${ftype} ${name}     105                         str="${ftype} ${name} ${location} ${str}"
107                         ;;                        106                         ;;
108                 "nod")                            107                 "nod")
109                         local dev="`LC_ALL=C l    108                         local dev="`LC_ALL=C ls -l "${location}"`"
110                         local maj=`field 5 ${d    109                         local maj=`field 5 ${dev}`
111                         local min=`field 6 ${d    110                         local min=`field 6 ${dev}`
112                         maj=${maj%,}              111                         maj=${maj%,}
113                                                   112 
114                         [ -b "${location}" ] &    113                         [ -b "${location}" ] && dev="b" || dev="c"
115                                                   114 
116                         str="${ftype} ${name}     115                         str="${ftype} ${name} ${str} ${dev} ${maj} ${min}"
117                         ;;                        116                         ;;
118                 "slink")                          117                 "slink")
119                         local target=`readlink    118                         local target=`readlink "${location}"`
120                         str="${ftype} ${name}     119                         str="${ftype} ${name} ${target} ${str}"
121                         ;;                        120                         ;;
122                 *)                                121                 *)
123                         str="${ftype} ${name}     122                         str="${ftype} ${name} ${str}"
124                         ;;                        123                         ;;
125         esac                                      124         esac
126                                                   125 
127         echo "${str}" >> $cpio_list               126         echo "${str}" >> $cpio_list
128                                                   127 
129         return 0                                  128         return 0
130 }                                                 129 }
131                                                   130 
132 unknown_option() {                                131 unknown_option() {
133         printf "ERROR: unknown option \"$arg\"    132         printf "ERROR: unknown option \"$arg\"\n" >&2
134         printf "If the filename validly begins    133         printf "If the filename validly begins with '-', " >&2
135         printf "then it must be prefixed\n" >&    134         printf "then it must be prefixed\n" >&2
136         printf "by './' so that it won't be in    135         printf "by './' so that it won't be interpreted as an option." >&2
137         printf "\n" >&2                           136         printf "\n" >&2
138         usage >&2                                 137         usage >&2
139         exit 1                                    138         exit 1
140 }                                                 139 }
141                                                   140 
142 header() {                                        141 header() {
143         printf "\n#####################\n# $1\    142         printf "\n#####################\n# $1\n" >> $cpio_list
144 }                                                 143 }
145                                                   144 
146 # process one directory (incl sub-directories)    145 # process one directory (incl sub-directories)
147 dir_filelist() {                                  146 dir_filelist() {
148         header "$1"                               147         header "$1"
149                                                   148 
150         srcdir=$(echo "$1" | sed -e 's://*:/:g    149         srcdir=$(echo "$1" | sed -e 's://*:/:g')
151         dirlist=$(find "${srcdir}" -printf "%p !! 150         dirlist=$(find "${srcdir}" -printf "%p %m %U %G\n" | LANG=C sort)
152                                                   151 
153         # If $dirlist is only one line, then t    152         # If $dirlist is only one line, then the directory is empty
154         if [  "$(echo "${dirlist}" | wc -l)" -    153         if [  "$(echo "${dirlist}" | wc -l)" -gt 1 ]; then
155                 print_mtime "$1"                  154                 print_mtime "$1"
156                                                   155 
157                 echo "${dirlist}" | \             156                 echo "${dirlist}" | \
158                 while read x; do                  157                 while read x; do
159                         list_parse $x             158                         list_parse $x
160                         parse $x                  159                         parse $x
161                 done                              160                 done
162         fi                                        161         fi
163 }                                                 162 }
164                                                   163 
165 input_file() {                                    164 input_file() {
166         source="$1"                               165         source="$1"
167         if [ -f "$1" ]; then                      166         if [ -f "$1" ]; then
168                 # If a regular file is specifi    167                 # If a regular file is specified, assume it is in
169                 # gen_init_cpio format            168                 # gen_init_cpio format
170                 header "$1"                       169                 header "$1"
171                 print_mtime "$1" >> $cpio_list    170                 print_mtime "$1" >> $cpio_list
172                 cat "$1"         >> $cpio_list    171                 cat "$1"         >> $cpio_list
173                 if [ -n "$dep_list" ]; then       172                 if [ -n "$dep_list" ]; then
174                         echo "$1 \\"  >> $dep_    173                         echo "$1 \\"  >> $dep_list
175                         cat "$1" | while read     174                         cat "$1" | while read type dir file perm ; do
176                                 if [ "$type" =    175                                 if [ "$type" = "file" ]; then
177                                         echo "    176                                         echo "$file \\" >> $dep_list
178                                 fi                177                                 fi
179                         done                      178                         done
180                 fi                                179                 fi
181         elif [ -d "$1" ]; then                    180         elif [ -d "$1" ]; then
182                 # If a directory is specified     181                 # If a directory is specified then add all files in it to fs
183                 dir_filelist "$1"                 182                 dir_filelist "$1"
184         else                                      183         else
185                 echo "  ${prog}: Cannot open '    184                 echo "  ${prog}: Cannot open '$1'" >&2
186                 exit 1                            185                 exit 1
187         fi                                        186         fi
188 }                                                 187 }
189                                                   188 
190 prog=$0                                           189 prog=$0
191 root_uid=0                                        190 root_uid=0
192 root_gid=0                                        191 root_gid=0
193 dep_list=                                         192 dep_list=
194 timestamp=                                     << 
195 cpio_list=$(mktemp ${TMPDIR:-/tmp}/cpiolist.XX    193 cpio_list=$(mktemp ${TMPDIR:-/tmp}/cpiolist.XXXXXX)
196 output="/dev/stdout"                              194 output="/dev/stdout"
197                                                   195 
198 trap "rm -f $cpio_list" EXIT                      196 trap "rm -f $cpio_list" EXIT
199                                                   197 
200 while [ $# -gt 0 ]; do                            198 while [ $# -gt 0 ]; do
201         arg="$1"                                  199         arg="$1"
202         shift                                     200         shift
203         case "$arg" in                            201         case "$arg" in
204                 "-l")   # files included in in    202                 "-l")   # files included in initramfs - used by kbuild
205                         dep_list="$1"             203                         dep_list="$1"
206                         echo "deps_initramfs :    204                         echo "deps_initramfs := \\" > $dep_list
207                         shift                     205                         shift
208                         ;;                        206                         ;;
209                 "-o")   # generate cpio image     207                 "-o")   # generate cpio image named $1
210                         output="$1"               208                         output="$1"
211                         shift                     209                         shift
212                         ;;                        210                         ;;
213                 "-u")   # map $1 to uid=0 (roo    211                 "-u")   # map $1 to uid=0 (root)
214                         root_uid="$1"             212                         root_uid="$1"
215                         [ "$root_uid" = "-1" ]    213                         [ "$root_uid" = "-1" ] && root_uid=$(id -u || echo 0)
216                         shift                     214                         shift
217                         ;;                        215                         ;;
218                 "-g")   # map $1 to gid=0 (roo    216                 "-g")   # map $1 to gid=0 (root)
219                         root_gid="$1"             217                         root_gid="$1"
220                         [ "$root_gid" = "-1" ]    218                         [ "$root_gid" = "-1" ] && root_gid=$(id -g || echo 0)
221                         shift                     219                         shift
222                         ;;                        220                         ;;
223                 "-d")   # date for file mtimes << 
224                         timestamp="$(date -d"$ << 
225                         if test -n "$timestamp << 
226                                 timestamp="-t  << 
227                         fi                     << 
228                         shift                  << 
229                         ;;                     << 
230                 "-h")                             221                 "-h")
231                         usage                     222                         usage
232                         exit 0                    223                         exit 0
233                         ;;                        224                         ;;
234                 *)                                225                 *)
235                         case "$arg" in            226                         case "$arg" in
236                                 "-"*)             227                                 "-"*)
237                                         unknow    228                                         unknown_option
238                                         ;;        229                                         ;;
239                                 *)      # inpu    230                                 *)      # input file/dir - process it
240                                         input_    231                                         input_file "$arg"
241                                         ;;        232                                         ;;
242                         esac                      233                         esac
243                         ;;                        234                         ;;
244         esac                                      235         esac
245 done                                              236 done
246                                                   237 
247 # If output_file is set we will generate cpio     238 # If output_file is set we will generate cpio archive
248 # we are careful to delete tmp files              239 # we are careful to delete tmp files
                                                   >> 240 timestamp=
                                                   >> 241 if test -n "$KBUILD_BUILD_TIMESTAMP"; then
                                                   >> 242         timestamp="$(date -d"$KBUILD_BUILD_TIMESTAMP" +%s || :)"
                                                   >> 243         if test -n "$timestamp"; then
                                                   >> 244                 timestamp="-t $timestamp"
                                                   >> 245         fi
                                                   >> 246 fi
249 usr/gen_init_cpio $timestamp $cpio_list > $out    247 usr/gen_init_cpio $timestamp $cpio_list > $output
                                                      

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php